/*
Note:
Only the wrapper code is under the zlib license,
the qfloat lib itself is Copyright (c) by Stephen L. Moshier http://www.moshier.net/

Released under the zlib/libpng License 
Copyright (c) 2005 Mirko Ellinger / Johan B Klassen 

This software is provided 'as-is', without any express or implied warranty. In no event will
the authors be held liable for any damages arising from the use of this software. 

Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it freely,
subject to the following restrictions: 

1. The origin of this software must not be misrepresented; you must not claim that you wrote the original software.
 If you use this software in a product, an acknowledgment in the product documentation
 would be appreciated but is not required. 

2. Altered source versions must be plainly marked as such, and must not be misrepresented
 as being the original software. 

3. This notice may not be removed or altered from any source distribution. 

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "qhead.h"
#include "mconf.h"

#ifdef VC6
  char _fltused;
#endif

/*
typedef struct qfloat {
	unsigned int ar[14];
} qfloat;

#ifndef ANSIPROT
e113toq( &d, q )	128-bit long double precision to q type
qtoe113( q, &d )	convert q type to 128-bit long double precision
*/

typedef struct ldouble {
	unsigned short int ar[7];
} ldouble;


int qadd(), qsub(), qmul(), qdiv(),qsqrt (), qremain(), qremquo();
int qcbrt (), qexp (), qlog (), qtan (), qatn ();
int qsin (), qasin (), qcos (), qacos (), qpow ();
int qtanh (), qatanh (), qsinh (), qasinh (), qcosh (), qacosh ();
int qexp2 (), qlogtwo (), qexp10 (), qlog10 ();
int qjn(), qyn(), qin(), qkn();
int qndtr(), qndtri(), qellpe(), qellpk(), qgamma(), qlgam();
int qtoasc(), asctoq(),qcmp(),qatn2(),qabs(),qneg(),qisneg(),qfac();
int qtoe24(), e24toq(), etoq(), qtoe(), e113toq(), qtoe113();
int drand(),qinfin(),qfloor(),qround();//qfloor( x, y ),qround(x, y)
int qradd(), qrsub(), qrmul(), qrdiv(), qeuclid(), qrand(), qispos();


extern QELT qzero[], qhalf[], qone[], qtwo[], qthree[], qnine[];
extern QELT q32[], qsqrt2[], qeul[],  qpi[], qlog2[], q__e[];
extern QELT qpinf[],qminf[];

qfract qrzero = {
0,0x0000,0,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,
0,0x8001,0,0x80000000,0x00000000,0x00000000,0x00000000,0x00000000,
0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000};

/* Provide inverses for square root and cube root: */
int 
qsquare (x, y)
     QELT x[], y[];
{
  qmul (x, x, y);
  return 0;
}

int 
qcube (x, y)
     QELT x[], y[];
{
  qmul (x, x, y);
  qmul (x, y, y);
  return 0;
}

extern char* PB_StringBase;

extern char* _stdcall PB_Q_StrExp(qfloat* d)
{
	int p,srch,j,l,ex;
	char* ResultString = PB_StringBase;
	char valstr[120],xp[10],c[10];
	p=6;
	qtoasc( d, valstr, p );
	srch = 1+strcspn( valstr, "E" );
	l=0;
	for (j=srch;j<=(srch+7);j++)
	{
		xp[l]=valstr[j];
		l=l+1;
	}
	valstr[srch-1]=0;
	ex = atoi( xp );
	sprintf(c,"%04d",abs(ex));
	if (ex<0) strcpy(xp,"-"); else strcpy(xp,"+");
	strcat(xp,c);
	strcat(valstr,"e");
	strcat(valstr,xp);
	
	strcpy(ResultString, valstr);
	PB_StringBase+=strlen(ResultString);
	*PB_StringBase=0;
	return ResultString;
}

extern char* _stdcall PB_Q_StrExp2(qfloat* d, int p)
{
	int pr,srch,j,l,ex;
	char* ResultString = PB_StringBase;
	char valstr[120],xp[10],c[10];
	pr=abs(p);
	if (pr>106)
		pr=106;
	qtoasc( d, valstr, p );
	srch = 1+strcspn( valstr, "E" );
	l=0;
	for (j=srch;j<=(srch+7);j++)
	{
		xp[l]=valstr[j];
		l=l+1;
	}
	valstr[srch-1]=0;
	ex = atoi( xp );
	sprintf(c,"%04d",abs(ex));
	if (ex<0) strcpy(xp,"-"); else strcpy(xp,"+");
	strcat(xp,c);
	strcat(valstr,"e");
	strcat(valstr,xp);
	
	strcpy(ResultString, valstr);
	PB_StringBase+=strlen(ResultString);
	*PB_StringBase=0;
	return ResultString;
}

extern char* _stdcall PB_Q_StrGen( qfloat *x1, int pl, int pr)
{

	char start[120],left[120],right[120],xp[120],c[120];
	char* ResultString = PB_StringBase;
	char valstr[120];

	qfloat power,temp,temp1,temp2,x;
	int ex,srch,j,l,p;
	long k;
	qmov(x1,&x);
	if (qisneg(&x))
	{
		strcpy(start,"-");
		qabs(&x);
	}
	else strcpy(start," ");

	if (qcmp(&x,qzero)!=0)
	{
		qlog10(&x,&temp);
		qfloor(&temp,&power);
	}
	else
		qmov(qzero,&power);
	asctoq("-4",&temp1);
	k=(long) pr-1;
	ltoq(&k,&temp2);
	if (qcmp(&power,&temp1)<0 || qcmp(&power,&temp2)>0)
	{
		qtoasc(&x,valstr,pr-1);
		srch = 1+strcspn( valstr, " " );
		l=0;
		for (j=srch;j<=120;j++)
		{
			valstr[l]=valstr[j];
			l=1+l;
		}
		srch = 1+strcspn( valstr, "E" );
		l=0;
		for (j=srch;j<=(srch+7);j++)
		{
			xp[l]=valstr[j];
			l=l+1;
		}
		valstr[srch-1]=0;
		l=0;
		while (valstr[l]!=0)
			l=l+1;
		l=l-1;
		while (valstr[l]=='0')
		{
			valstr[l]=0;
			l=l-1;
		}
		while (valstr[l]!=0)
			l=l+1;
		if (valstr[l-1]=='.') valstr[l-1]=0;
		ex = atoi( xp );
		sprintf(c,"%04d",abs(ex));
		if (ex<0) strcpy(xp,"-"); else strcpy(xp,"+");
		strcat(xp,c);
		strcpy(c,start);
		strcat(c,valstr);
		strcat(c,"e");
		strcat(c,xp);
		strcpy(valstr,c);
		p=0;
		while (valstr[p]!=0)
			p=p+1;
		p=p-1;
		if (p<pl)
		{
			for (l=0;l<(pl-p-1);l++)
			{
				c[l]=' ';
			}
			c[l]=0;
			strcat(c,valstr);
			strcpy(valstr,c);
		}
	}
	else
	{
		qtoasc(&x,valstr,pr-1);
		srch = 1+strcspn( valstr, " " );
		l=0;
		for (j=srch;j<=120;j++)
		{
			valstr[l]=valstr[j];
			l=1+l;
		}
		srch = 1+strcspn( valstr, "E" );
		l=0;
		for (j=srch;j<=(srch+7);j++)
		{
			xp[l]=valstr[j];
			l=l+1;
		}
		valstr[srch-1]=0;
		ex = atoi( xp );
		if (ex!=0)
		{
			p = 1+strcspn( valstr, "." );
			strncpy(left,valstr,p-1);
			left[p-1]=0;
			l=0;
			while (valstr[l+p]!=0)
			{
				right[l]=valstr[l+p];
				l=l+1;
			}
			right[l]=0;
			if (ex<0)
			{
				qtoasc(&x,valstr,pr-1);
				srch = 1+strcspn( valstr, " " );
				l=0;
				for (j=srch;j<=120;j++)
				{
					valstr[l]=valstr[j];
					l=1+l;
				}
				srch = 1+strcspn( valstr, "E" );
				valstr[srch-1]=0;
				p = 1+strcspn( valstr, "." );
				strncpy(left,valstr,p-1);
				left[p-1]=0;
				l=0;
				while (valstr[l+p]!=0)
				{
					right[l]=valstr[l+p];
					l=l+1;
				}
				right[l]=0;
				valstr[0]=0;
				strcpy(valstr,start);
				strcat(valstr,"0.");
				l=strlen(valstr);
				for (j=l;j<=(abs(ex)+1);j++)
					valstr[j]='0';
				valstr[j]=0;
				strcat(valstr,left);
				strcat(valstr,right);
				strcpy(c,valstr);
				l=0;
				while (c[l]!=0)
					l=l+1;
				l=l-1;
				while (c[l]=='0')
				{
					c[l]=0;
					l=l-1;
				}
				p=0;
				while (c[p]!=0)
					p=p+1;
				p=p-1;
				if (p<pl)
				{
					for (l=0;l<(pl-p-1);l++)
					{
						valstr[l]=' ';
					}
					valstr[l]=0;
					strcat(valstr,c);
				}
				else
					strcpy(valstr,c);
			}
			else
			{
				valstr[0]=0;
				strcpy(valstr,left);
				strcat(valstr,right);
				strncpy(left,valstr,ex+1);
				left[ex+1]=0;
				l=0;
				while (valstr[l+ex+1]!=0)
				{
					right[l]=valstr[l+ex+1];
					l=l+1;
				}
				right[l]=0;
				strcpy(valstr,start);
				strcat(valstr,left);
				strcat(valstr,".");
				strcat(valstr,right);
				l=0;
				while (valstr[l]!=0)
					l=l+1;
				l=l-1;
				while (valstr[l]=='0')
				{
					valstr[l]=0;
					l=l-1;
				}
				while (valstr[l]!=0)
					l=l+1;
				if (valstr[l-1]=='.') valstr[l-1]=0;
				p=0;
				while (valstr[p]!=0)
					p=p+1;
				p=p-1;
				if (p<pl)
				{
					for (l=0;l<(pl-p-1);l++)
					{
						c[l]=' ';
					}
					c[l]=0;
					strcat(c,valstr);
					strcpy(valstr,c);
				}

			}
		}
		else
		{
			strcpy(c,start);
			strcat(c,valstr);
			p=0;
			while (c[p]!=0)
				p=p+1;
			p=p-1;
			for (l=0;l<(pl-p-1);l++)
			{
				valstr[l]=' ';
			}
			valstr[l]=0;
			strcat(valstr,c);
			l=0;
			while (valstr[l]!=0)
				l=l+1;
			l=l-1;
			while (valstr[l]=='0')
			{
				valstr[l]=0;
				l=l-1;
			}
			l=0;
			while (valstr[l]!=0)
				l=l+1;
			if (valstr[l-1]=='.') valstr[l-1]=0;
			strcpy(c,valstr);
			p=0;
			while (valstr[p]!=0)
				p=p+1;
			if (p<pl)
			{
				for (l=0;l<(pl-p-1);l++)
				{
					valstr[l]=' ';
				}
				valstr[l]=0;
				strcat(valstr,c);
			}
		}
	}
	strcpy(ResultString, valstr);
	PB_StringBase+=strlen(ResultString);
	*PB_StringBase=0;
	return ResultString;
}

extern char* _stdcall PB_Q_StrFix( qfloat *x1, int pl, int pr)
{

	char start[120],left[120],right[120],xp[120],c[120];
	char* ResultString = PB_StringBase;
	char valstr[120];
	qfloat x;
	int ex,srch,j,l,p;
	qmov(x1,&x);
	if (qisneg(&x))
	{
		strcpy(start,"-");
		qabs(&x);
	}
	else strcpy(start,"");
	qtoasc(&x,valstr,pr);
	srch = 1+strcspn( valstr, " " );
	l=0;
	for (j=srch;j<=120;j++)
	{
		valstr[l]=valstr[j];
		l=1+l;
	}
	srch = 1+strcspn( valstr, "E" );
	l=0;
	for (j=srch;j<=(srch+7);j++)
	{
		xp[l]=valstr[j];
		l=l+1;
	}
	valstr[srch-1]=0;
	ex = atoi( xp );
	if (ex!=0)
	{
		if (ex<0)
		{
			qadd(&x , qone , &x);
			qtoasc(&x,valstr,pr);
			srch = 1+strcspn( valstr, " " );
			l=0;
			for (j=srch;j<=120;j++)
			{
				valstr[l]=valstr[j];
				l=1+l;
			}
			srch = 1+strcspn( valstr, "E" );
			valstr[srch-1]=0;
			p = 1+strcspn( valstr, "." );
			l=0;
			while (valstr[l+p]!=0)
			{
				right[l]=valstr[l+p];
				l=l+1;
			}
			right[l]=0;
			strcpy(valstr,start);
			strcat(valstr,".");
			strncat( valstr, right, pr+1 );
			p=0;
			while (valstr[p]!=0)
				p=p+1;
			p=p-1;
			if (p<pl)
			{
				for (l=0;l<(pl-p-1);l++)
				{
					c[l]=' ';
				}
				c[l]=0;
				strcat(c,valstr);
				strcpy(valstr,c);
			}
		}
		else
		{
			qtoasc(&x,valstr,pr+ex);
			srch = 1+strcspn( valstr, " " );
			l=0;
			for (j=srch;j<=120;j++)
			{
				valstr[l]=valstr[j];
				l=1+l;
			}
			srch = 1+strcspn( valstr, "E" );
			valstr[srch-1]=0;
			p = 1+strcspn( valstr, "." );
			strncpy(left,valstr,p-1);
			left[p-1]=0;
			l=0;
			while (valstr[l+p]!=0)
			{
				right[l]=valstr[l+p];
				l=l+1;
			}
			right[l]=0;
			strcpy(valstr,left);
			strcat(valstr,right);
			strcpy(c,start);
			strncat(c,valstr,ex+1);
			strcpy(left,c);
			p=0;
			while (valstr[p]!=0)
				p=p+1;
			p=p-1;
			l=0;
			for (j=ex+1;j<=120;j++)
			{
				right[l]=valstr[j];
				l=1+l;
			}
			strcpy(valstr,left);
			strcat(valstr,".");
			strcat(valstr,right);
			p=0;
			while (valstr[p]!=0)
				p=p+1;
			p=p-1;
			if (p<pl)
			{
				for (l=0;l<(pl-p-1);l++)
				{
					c[l]=' ';
				}
				c[l]=0;
				strcat(c,valstr);
				strcpy(valstr,c);
			}
		}
	}
	else
	{
		strcpy(c,start);
		strcat(c,valstr);
		strcpy(valstr,c);
		p=0;
		while (valstr[p]!=0)
			p=p+1;
		p=p-1;
		if (p<pl)
		{
			for (l=0;l<(pl-p-1);l++)
			{
				c[l]=' ';
			}
			c[l]=0;
			strcat(c,valstr);
			strcpy(valstr,c);
		}
	}
	if ((pl==0) && (start[0]!='-'))
	{
		strcpy(c," ");
		strcat(c,valstr);
		strcpy(valstr,c);
	}

	strcpy(ResultString, valstr);
	PB_StringBase+=strlen(ResultString);
	*PB_StringBase=0;
	return ResultString;
}	



extern qfloat* _stdcall PB_Q_Val(qfloat *d, char* s)
{
  asctoq(s,d);
  return d;
}

extern qfloat* _stdcall PB_Q_Add(qfloat* d1, qfloat* d2)
{
  qadd(d2 , d1,d1 );
  return d1;
}
extern qfloat* _stdcall PB_Q_Sub(qfloat* d1, qfloat* d2)
{
  qsub(d2 , d1,d1 );
  return d1;
}
extern qfloat* _stdcall PB_Q_Mul(qfloat* d1, qfloat* d2)
{
  qmul( d2 , d1,d1);
  return d1;
}
extern qfloat* _stdcall PB_Q_Div(qfloat* d1, qfloat* d2)
{
  qdiv(d2 , d1,d1);
  return d1;
}
extern qfloat* _stdcall PB_Q_Pow(qfloat* d1, qfloat* d2)
{
  qpow(d1, d2,d1);
  return d1;
}

extern qfloat* _stdcall PB_Q_Mod(qfloat* d1, qfloat* d2)
{
  qremain(d2, d1, d1);
  return d1;
}

extern qfloat* _stdcall PB_Q_Add2(qfloat* d1, qfloat* d2, qfloat* result)
{
  qadd(d2 , d1 , result);
  return result;
}
extern qfloat* _stdcall PB_Q_Sub2(qfloat* d1, qfloat* d2, qfloat* result)
{
  qsub(d2 , d1 , result);
  return result;
}
extern qfloat* _stdcall PB_Q_Mul2(qfloat* d1, qfloat* d2, qfloat* result)
{
  qmul(d2 , d1 , result);
  return result;
}
extern qfloat* _stdcall PB_Q_Div2(qfloat* d1, qfloat* d2, qfloat* result)
{
  qdiv(d2 , d1 , result);
  return result;
}
extern qfloat* _stdcall PB_Q_Pow2(qfloat* d1, qfloat* d2, qfloat* result)
{
  qpow(d1, d2, result);
  return result;
}

extern qfloat* _stdcall PB_Q_Mod2(qfloat* d1, qfloat* d2, qfloat* result)
{
  qremain(d2, d1, result);
  return result;
}

extern qfloat* _stdcall PB_Q_Inc(qfloat* d)
{
  qadd(d ,qone, d);
  return d;
}
extern qfloat* _stdcall PB_Q_Dec(qfloat* d)
{
  qsub(qone, d, d);
  return d;
}

extern qfloat* _stdcall PB_Q_Sin(qfloat* d)
{
  qsin(d,d);
  return d;
}
extern qfloat* _stdcall PB_Q_Cos(qfloat* d)
{
  qcos(d,d);
  return d;
}
extern qfloat* _stdcall PB_Q_Tan(qfloat* d)
{
  qtan(d,d);
  return d;
}

extern qfloat* _stdcall PB_Q_ASin(qfloat* d)
{
  qasin(d,d);
  return d;
}
extern qfloat* _stdcall PB_Q_ACos(qfloat* d)
{
  qacos(d,d);
  return d;
}
extern qfloat* _stdcall PB_Q_ATan(qfloat* d)
{
  qatn(d,d);
  return d;
}

extern qfloat* _stdcall PB_Q_SinH(qfloat* d)
{
  qsinh(d,d);
  return d;
}
extern qfloat* _stdcall PB_Q_CosH(qfloat* d)
{
  qcosh(d,d);
  return d;
}
extern qfloat* _stdcall PB_Q_TanH(qfloat* d)
{
  qtanh(d,d);
  return d;
}

extern qfloat* _stdcall PB_Q_ASinH(qfloat* d)
{
  qasinh(d,d);
  return d;
}
extern qfloat* _stdcall PB_Q_ACosH(qfloat* d)
{
	qacosh(d,d);
	return d;
}
extern qfloat* _stdcall PB_Q_ATanH(qfloat* d)
{
	qatanh(d,d);
	return d;
}

extern qfloat* _stdcall PB_Q_Cot(qfloat* d)
{
	qfloat x;
	qtan(d,&x);
	qdiv(&x,qone,d);
    return d;
}
extern qfloat* _stdcall PB_Q_CotH(qfloat* d)
{
	qfloat x;
	qtanh(d,&x);
	qdiv(&x,qone,d);
	return d;
}
extern qfloat* _stdcall PB_Q_ACotH(qfloat* d)
{
	qfloat x;
	qdiv(d,qone,&x);
	qatanh(&x,d);
	return d;
}
extern qfloat* _stdcall PB_Q_Sin2(qfloat* d, qfloat* result)
{
  qsin(d,result);
  return result;
}
extern qfloat* _stdcall PB_Q_Cos2(qfloat* d, qfloat* result)
{
  qcos(d,result);
  return result;
}
extern qfloat* _stdcall PB_Q_Tan2(qfloat* d, qfloat* result)
{
  qtan(d,result);
  return result;
}

extern qfloat* _stdcall PB_Q_ASin2(qfloat* d, qfloat* result)
{
  qasin(d,result);
  return result;
}
extern qfloat* _stdcall PB_Q_ACos2(qfloat* d, qfloat* result)
{
  qacos(d,result);
  return result;
}
extern qfloat* _stdcall PB_Q_ATan2(qfloat* d, qfloat* result)
{
  qatn(d,result);
  return result;
}

extern qfloat* _stdcall PB_Q_SinH2(qfloat* d, qfloat* result)
{
  qsinh(d,result);
  return result;
}
extern qfloat* _stdcall PB_Q_CosH2(qfloat* d, qfloat* result)
{
  qcosh(d,result);
  return result;
}
extern qfloat* _stdcall PB_Q_TanH2(qfloat* d, qfloat* result)
{
  qtanh(d,result);
  return result;
}

extern qfloat* _stdcall PB_Q_ASinH2(qfloat* d, qfloat* result)
{
  qasinh(d,result);
  return result;
}
extern qfloat* _stdcall PB_Q_ACosH2(qfloat* d, qfloat* result)
{
	qacosh(d,result);
	return result;
}
extern qfloat* _stdcall PB_Q_ATanH2(qfloat* d, qfloat* result)
{
	qatanh(d,result);
	return result;
}

extern qfloat* _stdcall PB_Q_Cot2(qfloat* d, qfloat* result)
{
	qfloat x;
	qtan(d,&x);
	qdiv(&x,qone,result);
    return result;
}
extern qfloat* _stdcall PB_Q_CotH2(qfloat* d, qfloat* result)
{
	qfloat x;
	qtanh(d,&x);
	qdiv(&x,qone,result);
	return result;
}
extern qfloat* _stdcall PB_Q_ACotH2(qfloat* d, qfloat* result)
{
	qfloat x;
	qdiv(d,qone,&x);
	qatanh(&x,result);
	return result;
}

extern qfloat* _stdcall PB_Q_LN2(qfloat* d, qfloat* result)
{
  qlog(d,result);
  return result;
}
extern qfloat* _stdcall PB_Q_Log2(qfloat* d, qfloat* result)
{
  qlog10(d,result);
  return result;
}

extern qfloat* _stdcall PB_Q_Abs2(qfloat* d, qfloat* result)
{
	qmov(d,result);
	qabs(result);
	return result;
}

extern qfloat* _stdcall PB_Q_Sqrt2(qfloat* d, qfloat* result)
{
  qsqrt(d,result);
  return result;
}
extern qfloat* _stdcall PB_Q_Exp2(qfloat* d, qfloat* result)
{
  qexp(d,result);
  return result;
}
extern qfloat* _stdcall PB_Q_Negate2(qfloat* d, qfloat* result)
{
	qmov(d,result);
	qneg(result);
	return result;
}

extern qfloat* _stdcall PB_Q_PI(qfloat* result)
{
  qmov(qpi,result);
  return result;
}

extern qfloat* _stdcall PB_Q_E(qfloat* result)
{
  qmov(q__e,result);
  return result;
}
extern qfloat* _stdcall PB_Q_Negate(qfloat* d)
{
	qneg(d);
	return d;
}
extern qfloat* _stdcall PB_Q_Sqrt(qfloat* d)
{
  qsqrt(d,d);
  return d;
}
extern qfloat* _stdcall PB_Q_Abs(qfloat* d)
{
	qabs(d);
	return d;
}
extern qfloat* _stdcall PB_Q_Exp(qfloat* d)
{
  qexp(d,d);
  return d;
}
extern qfloat* _stdcall PB_Q_ExpTen(qfloat* d)
{
  qexp10(d,d);
  return d;
}
extern qfloat* _stdcall PB_Q_ExpTen2(qfloat* d, qfloat* result)
{
  qexp10(d,result);
  return result;
}


extern int _stdcall PB_Q_Cmp(qfloat* d1, qfloat* d2)
{
  return qcmp(d1,d2);
}
extern int _stdcall PB_Q_Cmp2(qfloat* d1, qfloat* d2, qfloat* d3)
{
	long k;
	k=qcmp(d1,d2);
	ltoq(&k,d3);
	return (int) k;
}
extern int _stdcall PB_Q_Equ(qfloat* d1, qfloat* d2)
{
  if(qcmp(d1,d2)==0)
    return 1;
  return 0;
}
extern int _stdcall PB_Q_Equ2(qfloat* d1, qfloat* d2, qfloat* d3)
{
	long k=0;
	if(qcmp(d1,d2)==0)
		k=1;
	ltoq(&k,d3);
	return (int) k;
}
extern void _stdcall PB_Q_Copy(qfloat* d1, qfloat* d2)
{
	qmov(d2,d1);
}
extern void _stdcall PB_Q_Swap(qfloat* d1, qfloat* d2)
{
  qfloat h;
  qmov(d1,&h);
  qmov(d2,d1);
  qmov(&h,d2);
}

extern qfloat* _stdcall PB_Q_LN(qfloat* d)
{
  qlog(d,d);
  return d;
}
extern qfloat* _stdcall PB_Q_Log(qfloat* d)
{
  qlog10(d,d);
  return d;
}

extern float _stdcall PB_Q_Version(void)
{
	return (float) 0.1;
}

extern qfloat* _stdcall PB_Q_Frac(qfloat* d1)
{
	qfloat num,frac_part;
	long int_part;
	qmov(d1,&num);
    qabs(&num);
	qifrac(&num,&int_part,&frac_part);
	if (qisneg(d1))
		qneg(&frac_part);
	qmov(&frac_part,d1);
	return d1;
}
extern qfloat* _stdcall PB_Q_Frac2(qfloat* d1, qfloat* d2)
{
	qfloat num,frac_part;
	long int_part;
	qmov(d1,&num);
    qabs(&num);
	qifrac(&num,&int_part,&frac_part);
	if (qisneg(d1))
		qneg(&frac_part);
	qmov(&frac_part,d2);
	return d2;
}

extern qfloat* _stdcall PB_Q_Integer(qfloat* d1)
{
	qfloat num,frac_part;
	long int_part;
	qmov(d1,&num);
    qabs(&num);
	qifrac(&num,&int_part,&frac_part);
	qsub(&frac_part,&num,&num);
	if (qisneg(d1))
		qneg(&num);
	qmov(&num,d1);
	return d1;
}
extern qfloat* _stdcall PB_Q_Integer2(qfloat* d1, qfloat* d2)
{
	qfloat num,frac_part;
	long int_part;
	qmov(d1,&num);
    qabs(&num);
	qifrac(&num,&int_part,&frac_part);
	qsub(&frac_part,&num,&num);
	if (qisneg(d1))
		qneg(&num);
	qmov(&num,d2);
	return d2;
}
extern qfloat* _stdcall PB_Q_Int(qfloat* d1, int n)
{
	long k;
	k=(long) n;
	ltoq(&k,d1);
	return d1;
}
extern int _stdcall PB_Q_IsInt(qfloat* d1)
{
	qfloat num,frac_part;
	long int_part;
	qmov(d1,&num);
    qabs(&num);
	qifrac(&num,&int_part,&frac_part);
	if (qcmp(&frac_part,qzero)==0)
		return 1;
  	else
	  return 0;
}

extern int _stdcall PB_Q_Sign(qfloat* d1)
{
	return qcmp(d1,qzero);
}
extern int _stdcall PB_Q_Sign2(qfloat* d1, qfloat* d2)
{
	long n;
	n=qcmp(d1,qzero);
	ltoq(&n,d2);
	return (int) n;
}
extern qfloat* _stdcall PB_Q_AtanQuad(qfloat* d1, qfloat* d2)
{
	qatn2(d2,d1,d1);
	return d1;
}
extern qfloat* _stdcall PB_Q_AtanQuad2(qfloat* d1, qfloat* d2, qfloat* d3)
{
	qatn2(d2,d1,d3);
	return d3;
}
extern int _stdcall PB_Q_toInt(qfloat* d1)
{
	qfloat frac_part;
	long int_part;
	qifrac(d1,&int_part,&frac_part);
	return (int) int_part;
}
extern qfloat* _stdcall PB_Q_iDiv(qfloat* d1, qfloat* d2)
{
	qfloat num,frac_part;
	long int_part;
	qdiv(d2,d1,&num);
    qabs(&num);
	qifrac(&num,&int_part,&frac_part);
	qsub(&frac_part,&num,&num);
	if (qisneg(d1)||qisneg(d2))
		qneg(&num);
	qmov(&num,d1);
	return d1;
}
extern qfloat* _stdcall PB_Q_iDiv2(qfloat* d1, qfloat* d2, qfloat* d3)
{
	qfloat num,frac_part;
	long int_part;
	qdiv(d2,d1,&num);
    qabs(&num);
	qifrac(&num,&int_part,&frac_part);
	qsub(&frac_part,&num,&num);
	if (qisneg(d1)||qisneg(d2))
		qneg(&num);
	qmov(&num,d3);
	return d3;
}
extern qfloat* _stdcall PB_Q_Inv(qfloat* d1)
{
	qdiv(d1,qone,d1);
	return d1;
}
extern qfloat* _stdcall PB_Q_Inv2(qfloat* d1, qfloat* d2)
{
	qdiv(d1,qone,d2);
	return d2;
}
extern qfloat* _stdcall PB_Q_Cbrt(qfloat* d1)
{
	qcbrt(d1,d1);
	return d1;
}
extern qfloat* _stdcall PB_Q_Cbrt2(qfloat* d1, qfloat* d2)
{
	qcbrt(d1,d2);
	return d2;
}


extern qfloat* _stdcall PB_Q_Factorial(qfloat* d1)
{
	qfloat num,frac_part;
	long int_part;
	int n;
	qmov(d1,&num);
    qabs(&num);
	qifrac(&num,&int_part,&frac_part);
	if (qcmp(&frac_part,qzero)==0)
		n=1;
  	else
	  n=0;
	if (n>0)   /*if d1 is integer*/
	{
	  	if (qisneg(d1))
			qinfin( d1 );				/*if d1 is negative integer, set d1 to infinity*/
		else
			qfac(d1,d1);
	}
	else
	{
		qadd(d1,qone,d1);
		qgamma(d1,d1);	 /*if d1 is not an integer return gamma(d1+1)*/
	}
	return d1;
}
extern qfloat* _stdcall PB_Q_Factorial2(qfloat* d1, qfloat* d2)
{
	qfloat num,frac_part;
	long int_part;
	int n;
	qmov(d1,&num);
    qabs(&num);
	qifrac(&num,&int_part,&frac_part);
	if (qcmp(&frac_part,qzero)==0)
		n=1;
  	else
	  n=0;
	if (n>0)   /*if d1 is integer*/
	{
	  	if (qisneg(d1))
			qinfin( d2 );				/*if d1 is negative integer, set d1 to infinity*/
		else
			qfac(d1,d2);
	}
	else
	{
		qadd(d1,qone,d2);
		qgamma(d2,d2);	 /*if d1 is not an integer return gamma(d1+1)*/
	}
	return d2;
}
extern qfloat* _stdcall PB_Q_Ceil(qfloat* d1)
{
	qfloat tmp,tmp1;
	qfloor(d1,&tmp);
	qsub(d1,&tmp,&tmp1);
	if (qcmp(&tmp1,qzero)!=0)
		qadd(qone,&tmp,d1);
	else
		qmov(&tmp,d1);
	return d1;
}
extern qfloat* _stdcall PB_Q_Ceil2(qfloat* d1, qfloat* d2)
{
	qfloat tmp,tmp1;
	qfloor(d1,&tmp);
	qsub(d1,&tmp,&tmp1);
	if (qcmp(&tmp1,qzero)!=0)
		qadd(qone,&tmp,d2);
	else
		qmov(&tmp,d2);
	return d2;
}
extern qfloat* _stdcall PB_Q_Floor(qfloat* d1)
{
	qfloor(d1,d1);
	return d1;
}
extern qfloat* _stdcall PB_Q_Floor2(qfloat* d1, qfloat* d2)
{
	qfloor(d1,d2);
	return d2;
}
extern qfloat* _stdcall PB_Q_Round(qfloat* d1, int n)
{
	qfloat tmp,tmp1;
	long p=(long) abs(n);
	if (p>105)
		p=105;
	ltoq(&p,&tmp);
	qexp10 (&tmp,&tmp);
	qmul(&tmp,d1,&tmp1);
	qround(&tmp1,&tmp1);
	qdiv(&tmp,&tmp1,d1);
	return d1;
}

extern qfloat* _stdcall PB_Q_Round2(qfloat* d1, int n, qfloat* d2)
{
	qfloat tmp,tmp1;
	long p=(long) abs(n);
	if (p>105)
		p=105;
	ltoq(&p,&tmp);
	qexp10 (&tmp,&tmp);
	qmul(&tmp,d1,&tmp1);
	qround(&tmp1,&tmp1);
	qdiv(&tmp,&tmp1,d2);
	return d2;
}
extern qfloat* _stdcall PB_Q_Float(qfloat* d, float f)
{
	e24toq( &f, d );
	return d;
}
extern float _stdcall PB_Q_toFloat(qfloat* d)
{
	float f;
	qtoe24( d, &f );
	return f;
}
extern qfloat* _stdcall PB_Q_Double(qfloat* q, double* d)
{
	etoq( d, q );
	return q;
}
extern double* _stdcall PB_Q_toDouble(double* d, qfloat* q)
{
	qtoe( q, d );
	return d;
}

extern ldouble* _stdcall PB_Q_toLDouble(ldouble* d, qfloat* q)
{	
	short unsigned int x0,x1,x2,x3,x4;
/*	char str[28];
	qfloat temp;
	qtoasc (q, str, 20);
	asctoq(str,&temp);
	qtoe113( &temp, d );*/
	qtoe113( q, d );
	x0=d->ar[3];
	x1=d->ar[4];
	x2=d->ar[5];
	x3=d->ar[6];
	x4=d->ar[7];
	_asm{
		sar x3,1
		rcr x2,1
		rcr x1,1
		rcr x0,1
	}
	
	d->ar[0]=x0;
	d->ar[1]=x1;
	d->ar[2]=x2;
	d->ar[3]=x3;
	d->ar[4]=x4;
	return d;
}
extern qfloat* _stdcall PB_Q_LDouble(qfloat* q, ldouble* ld)
{
	short unsigned int x0,x1,x2,x3,x4;
	ldouble d;
	x0=ld->ar[0];
	x1=ld->ar[1];
	x2=ld->ar[2];
	x3=ld->ar[3];
	x4=ld->ar[4];
	_asm{
		sal x0,1
		rcl x1,1
		rcl x2,1
		rcl x3,1
	}
	d.ar[0]=0;
	d.ar[1]=0;
	d.ar[2]=0;
	d.ar[3]=x0;
	d.ar[4]=x1;
	d.ar[5]=x2;
	d.ar[6]=x3;
	d.ar[7]=x4;
	e113toq( &d, q );
	return q;
}


extern qfract* _stdcall PB_Q_Radd(qfract* a, qfract* b)
{
	qradd( b, a, a );
	return a;
}
extern qfract* _stdcall PB_Q_Rsub(qfract* a, qfract* b)
{
	qrsub( b, a, a );
	return a;
}
extern qfract* _stdcall PB_Q_Rmul(qfract* a, qfract* b)
{
	qrmul( b, a, a );
	return a;
}
extern qfract* _stdcall PB_Q_Rdiv(qfract* a, qfract* b)
{
	qrdiv( b, a, a );
	return a;
}
extern qfract* _stdcall PB_Q_Radd2(qfract* a, qfract* b, qfract* c)
{
	qradd( b, a, c );
	return c;
}
extern qfract* _stdcall PB_Q_Rsub2(qfract* a, qfract* b, qfract* c)
{
	qrsub( b, a, c );
	return c;
}
extern qfract* _stdcall PB_Q_Rmul2(qfract* a, qfract* b, qfract* c)
{
	qrmul( b, a, c );
	return c;
}
extern qfract* _stdcall PB_Q_Rdiv2(qfract* a, qfract* b, qfract* c)
{
	qrdiv( b, a, c );
	return c;
}

extern qfract* _stdcall PB_Q_Rval(qfract* qf, char *v)
{
	char num[120],den[120],temp[120];
	int srch,j,l,s;
	unsigned int k;
	qfloat gcd;

	strcpy(num, v);
	srch = 1+strcspn( num, "/" );
	if (num[srch-1]=='/')
	{
		l=0;
		for (k=srch;k<=strlen(num);k++)
		{
			den[l]=num[k];
			l=l+1;
		}
		den[l]=0;
		num[srch-1]=0;
		s=strcspn( num, "-" );
		j=strcspn( den, "-" );
		if ((num[s]=='-')&&(den[j]=='-'))
		{
			num[s]=' ';
			den[j]=' ';
		}
		if (den[j]=='-')
		{
			den[j]=' ';
			strcpy(temp,"-");
			strcat(temp,num);
			strcpy(num,temp);
		}
		asctoq(num,qf->n);
		asctoq(den,qf->d);
		qeuclid(qf->n,qf->d,&gcd);
	}
	else
	{
		asctoq(num,qf->n);
		qmov(qone,qf->d);
	}
	return qf;
}

extern char* _stdcall PB_Q_Rstr( qfract *y)
{
	int srch,j,l,p,ex,sn,sd;
	unsigned int k;
	char num[120],den[120],xp[10],left[120],right[120],valstr[256];
	char* ResultString = PB_StringBase;
	qfract z;
	qmov(y->n,&z.n);
	qmov(y->d,&z.d);
	sn=qisneg(&z.n);
	sd=qisneg(&z.d);
	qabs(&z.n);
	qabs(&z.d);
	qtoasc(&z.n,num,106);		
	qtoasc(&z.d,den,106);
	srch = 1+strcspn( num, "E" );
	l=0;
	for (j=srch;j<=(srch+7);j++)
	{
		xp[l]=num[j];
		l=l+1;
	}
	num[srch-1]=0;
	ex=atoi(xp);
	p = 1+strcspn( num, "." );
	strncpy(left,num,p-1);
	left[p-1]=0;
	l=0;
	while (num[l+p]!=0)
	{
		right[l]=num[l+p];
		l=l+1;
	}
	right[l]=0;
	strcpy(valstr,left);
	strcat(valstr,right);
	for (j=0;j<=(ex+1);j++)
		num[j]=valstr[j];
	num[j]=0;
	
	srch = 1+strcspn( den, "E" );
	l=0;
	for (j=srch;j<=(srch+7);j++)
	{
		xp[l]=den[j];
		l=l+1;
	}
	den[srch-1]=0;
	ex=atoi(xp);
	p = 1+strcspn( den, "." );
	strncpy(left,den,p-1);
	left[p-1]=0;
	l=0;
	while (den[l+p]!=0)
	{
		right[l]=den[l+p];
		l=l+1;
	}
	right[l]=0;
	strcpy(valstr,left);
	strcat(valstr,right);
	for (j=0;j<=(ex+1);j++)
		den[j]=valstr[j];
	den[j]=0;
	if (sn!=sd)
		num[0]='-';
	for (k=0;k<=strlen(den);k++)//remove leading space
		den[k]=den[k+1];
	den[k]=0;
	if ((qcmp(&z.n,qzero)==0)||(qcmp(&z.d,qone)==0))
	{
		strcpy(valstr,num);
	}
	else
	{
		strcpy(valstr,num);
		strcat(valstr,"/");
		strcat(valstr,den);
	}
	strcpy(ResultString, valstr);
	PB_StringBase+=strlen(ResultString);
	*PB_StringBase=0;
	return ResultString;

}

extern int _stdcall PB_Q_Rcmp(qfract *y, qfract *x)
{
	qfract f;
	int z;
	qrsub(x,y,&f);
	z=qcmp(&f.n,qzero);
	return z;
}

extern int _stdcall PB_Q_REQ(qfract* d1, qfract* d2)
{
	int f;
	f=PB_Q_Rcmp(d1,d2);
	if (f==0) f=1; else f=0;
	return f;
}

extern int _stdcall PB_Q_RNE(qfract* d1, qfract* d2)
{
	int f;
	f=PB_Q_Rcmp(d1,d2);
	if (f!=0) f=1; else f=0;
	return f;
}

extern int _stdcall PB_Q_RLT(qfract* d1, qfract* d2)
{
	int f;
	f=PB_Q_Rcmp(d1,d2);
	if (f<0) f=1; else f=0;
	return f;
}

extern int _stdcall PB_Q_RGT(qfract* d1, qfract* d2)
{
	int f;
	f=PB_Q_Rcmp(d1,d2);
	if (f==1) f=1; else f=0;
	return f;
}

extern int _stdcall PB_Q_RLE(qfract* d1, qfract* d2)
{
	int f;
	f=PB_Q_Rcmp(d1,d2);
	if ((f<0) || (f==0)) f=1; else f=0;
	return f;
}

extern int _stdcall PB_Q_RGE(qfract* d1, qfract* d2)
{
	int f;
	f=PB_Q_Rcmp(d1,d2);
	if ((f==1) || (f==0)) f=1; else f=0;
	return f;
}

extern int _stdcall PB_Q_RisNeg(qfract* d1)
{
	int f;
	f=PB_Q_Rcmp(d1,&qrzero);
	if (f<0) f=1; else f=0;
	return f;
}

extern int _stdcall PB_Q_RisPos(qfract* d1)
{
	int f;
	f=PB_Q_Rcmp(d1,&qrzero);
	if (f==1) f=1; else f=0;
	return f;
}

extern int _stdcall PB_Q_RisZero(qfract* d1)
{
	int f;
	f=PB_Q_Rcmp(d1,&qrzero);
	if (f==0) f=1; else f=0;
	return f;
}

extern int _stdcall PB_Q_RisInteger(qfract* d1)
{
	int f;
	f=qcmp(d1->d,qone);
	if (f==0) f=1; else f=0;
	return f;
}

extern qfract* _stdcall PB_Q_Rabs(qfract* d1)
{
	qabs(d1->n);
	qabs(d1->d);
	return d1;
}

extern qfract* _stdcall PB_Q_Rnegate( qfract* d1)
{
	qrsub(d1,&qrzero,d1);
	return d1;
}

extern qfloat* _stdcall PB_Q_RtoQfloat(qfloat* result, qfract* d1)
{
	if (qcmp(d1->d,qone)==0)
	{
		qmov(d1->n,result);
	}
	else
	{
		qdiv(d1->d , d1->n , result);
	}
	return result;
}

extern void _stdcall PB_Q_Rcopy(qfract* result,qfract* d1)
{
	qmov(d1->n,result->n);
	qmov(d1->d,result->d);
}

extern qfloat* _stdcall PB_Q_SetInfinity(qfloat* d1)
{
	qinfin(d1);
	return d1;
}
extern qfloat* _stdcall PB_Q_SetInfinity2(qfloat* d1,int d2)
{
	long k;
	k=(long) d2;
	ltoq(&k,d1);
	qinfin(d1);
	return d1;
}
extern int _stdcall PB_Q_IsInfinite(qfloat* d1)
{
	if (qcmp(qpinf,d1)==0)
		return 1;
	else
	if (qcmp(qminf,d1)==0)
		return -1;
	else
	return 0;
}
extern int _stdcall PB_Q_IsInfinite2(qfloat* d1, qfloat* d2)
{
	qmov(qzero,d2);
	if (qcmp(qpinf,d1)==0)
	{
		qmov(qone,d2);
		return 1;
	}
	else
	if (qcmp(qminf,d1)==0)
	{
		qmov(qone,d2);
		qneg(d2);
		return -1;
	}
	else
	return 0;
}

extern int _stdcall PB_Q_IsOdd(qfloat* d1)
{
	qfloat num,frac_part,b,c;
	long int_part;
	int_part=2;
	ltoq(&int_part,&b);/*b=2*/
	qmov(d1,&num);
    qabs(&num);
	qifrac(&num,&int_part,&frac_part);
	int_part=0;
	if (qcmp(&frac_part,qzero)==0)
	{
		qremain(&b,d1,&c);
		if (qcmp(qzero,&c)!=0)
			int_part=1;
	}
	return int_part;
}
extern int _stdcall PB_Q_IsOdd2(qfloat* d1,qfloat* d2)
{
	qfloat num,frac_part,b,c;
	long int_part;
	int_part=2;
	ltoq(&int_part,&b);//b=2
	qmov(d1,&num);
    qabs(&num);
	qifrac(&num,&int_part,&frac_part);
	int_part=0;
	if (qcmp(&frac_part,qzero)==0)
	{
		qremain(&b,d1,&c);
		if (qcmp(qzero,&c)!=0)
		{
			qmov(qone,d2);
			int_part=1;
		}
	}
	else
	{
			qmov(qzero,d2);
	}
	return int_part;
}
extern int _stdcall PB_Q_IsEven(qfloat* d1)
{
	qfloat num,frac_part,b,c;
	long int_part;
	int_part=2;
	ltoq(&int_part,&b);/*b=2*/
	qmov(d1,&num);
    qabs(&num);
	qifrac(&num,&int_part,&frac_part);
	int_part=0;
	if (qcmp(&frac_part,qzero)==0)
	{
		qremain(&b,d1,&c);
		if (qcmp(qzero,&c)==0)
			int_part=1;
	}
	return int_part;
}
extern int _stdcall PB_Q_IsEven2(qfloat* d1,qfloat* d2)
{
	qfloat num,frac_part,b,c;
	long int_part;
	int_part=2;
	ltoq(&int_part,&b);/*b=2*/
	qmov(d1,&num);
    qabs(&num);
	qifrac(&num,&int_part,&frac_part);
	int_part=0;
	if (qcmp(&frac_part,qzero)==0)
	{
		qremain(&b,d1,&c);
		if (qcmp(qzero,&c)==0)
		{
			qmov(qone,d2);
			int_part=1;
		}
	}
	else
	{
			qmov(qzero,d2);
	}
	return int_part;
}

extern int _stdcall PB_Q_EQ(qfloat* d1, qfloat* d2)
{
	int f;
	f=qcmp(d1,d2);
	if (f==0) f=1; else f=0;
	return f;
}

extern int _stdcall PB_Q_NE(qfloat* d1, qfloat* d2)
{
	int f;
	f=qcmp(d1,d2);
	if (f!=0) f=1; else f=0;
	return f;
}

extern int _stdcall PB_Q_LT(qfloat* d1, qfloat* d2)
{
	int f;
	f=qcmp(d1,d2);
	if (f<0) f=1; else f=0;
	return f;
}

extern int _stdcall PB_Q_GT(qfloat* d1, qfloat* d2)
{
	int f;
	f=qcmp(d1,d2);
	if (f==1) f=1; else f=0;
	return f;
}

extern int _stdcall PB_Q_LE(qfloat* d1, qfloat* d2)
{
	int f;
	f=qcmp(d1,d2);
	if ((f<0) || (f==0)) f=1; else f=0;
	return f;
}

extern int _stdcall PB_Q_GE(qfloat* d1, qfloat* d2)
{
	int f;
	f=qcmp(d1,d2);
	if ((f==1) || (f==0)) f=1; else f=0;
	return f;
}

extern int _stdcall PB_Q_IsNegative(qfloat* d1)
{
	return qisneg(d1);
}
extern int _stdcall PB_Q_IsNegative2(qfloat* d1,qfloat* d2)
{
	long k;
	k=(long) qisneg(d1);
	ltoq(&k,d2);
	return (int) k;
}
extern int _stdcall PB_Q_IsPositive(qfloat* d1)
{
	return qispos(d1);
}
extern int _stdcall PB_Q_IsPositive2(qfloat* d1,qfloat* d2)
{
	long k;
	k=(long) qispos(d1);
	ltoq(&k,d2);
	return (int) k;
}


extern qfloat* _stdcall PB_Q_Gcd(qfloat* d1,qfloat* d2)
{
	QELT k[NQ],m[NQ];
	qmov(d1,k);
	qmov(d2,m);
	qeuclid( k, m, d1 );
	return d1;
}
extern qfloat* _stdcall PB_Q_Gcd2(qfloat* d1,qfloat* d2,qfloat* d3)
{
	QELT k[NQ],m[NQ];
	qmov(d1,k);
	qmov(d2,m);
	qeuclid( k, m, d3 );
	return d3;
}
extern qfloat* _stdcall PB_Q_Lcm(qfloat* d1,qfloat* d2)
{
	QELT k[NQ],m[NQ],n[NQ];
	qmov(d1,k);
	qmov(d2,m);
	qeuclid( k, m, n );
	qmul(d1,d2,m);
	qdiv(n,m,d1);
	return d1;
}
extern qfloat* _stdcall PB_Q_Lcm2(qfloat* d1,qfloat* d2,qfloat* d3)
{
	QELT k[NQ],m[NQ],n[NQ];
	qmov(d1,k);
	qmov(d2,m);
	qeuclid( k, m, n );
	qmul(d1,d2,m);
	qdiv(n,m,d3);
	return d3;
}
extern qfloat* _stdcall PB_Q_Random(qfloat* d1)
{
	qrand(d1);
	return d1;
}

